using System;
using System.Text;
using System.IO;
using System.Drawing;
//using System.Drawing.Drawing2D;
//using System.Drawing.Imaging;

//using ImgCutoutClient.edu.jhu.pha.skyservice;  //needed when compiling inside Visual Studio

namespace ImgCutoutClient
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class ImgCutoutClient
	{
		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main(string[] args)
		{
			
			String fname = "DR1Default.jpg";
			double ra= 195.162;
			double dec= 2.5;
			double scale = 0.396127;
			int width = 512;
			int height = 512;
			String opt="";            				

			// Validate input
			int ind =0;
			if (args.Length == 7) 
			{
				fname = args[ind++];
				ra = Convert.ToDouble(args[ind++]);
				dec = Convert.ToDouble(args[ind++]);
				scale = Convert.ToDouble(args[ind++]);
				width = Convert.ToInt32(args[ind++]);
				height = Convert.ToInt32(args[ind++]);
				opt = args[ind++];
			} 
			else if (args.Length > 0) 
			{
				StringBuilder message = new StringBuilder();
				message.Append("Pass no args to use the defaults otherwise pass:");
				message.Append("FileName RA DEC SCALE WIDTH HEIGHT OPTIONS");
				throw new Exception(message.ToString());
			}

			ImgCutoutClient cl = new ImgCutoutClient();
			cl.retrieveImage(fname, ra, dec, scale, width, height, opt);
		}
		
		public void retrieveImage(String fname, double ra, double dec,
			double scale, int width, int height , 
			String opt )
		{
				
			ImgCutout service = new ImgCutout();
			Byte[] theJpeg = service.GetJpeg(ra, dec, scale, width, height, opt); 
			
			FileStream fs = File.Create(fname);
			fs.Write(theJpeg,0,theJpeg.Length);
			fs.Close();

		}        
	}
}
